package model

import (
	"Panel_development/global"
	"encoding/json"
	"gorm.io/gorm"
	"time"
)

type ComponentList struct {
	gorm.Model
	Name        string `gorm:"type:varchar(255);not null;unique;comment:组件名称" json:"name" validate:"required"`
	Image       string `gorm:"type:varchar(255);not null;comment:组件图片" json:"image" validate:"required"`
	ImageName   string `gorm:"type:varchar(255);comment:组件图片名称" json:"image_name" validate:"required"`
	Data        string `gorm:"type:longtext;comment:组件数据" json:"data" validate:"required"`
	ComponentId int    `gorm:"type:int;comment:组件ID" json:"component_id" validate:"required"`
}

func (c ComponentList) TableName() string {
	return "component_list"
}
func (ab *ComponentList) MarshalJSON() ([]byte, error) {
	loc, _ := time.LoadLocation("Asia/Shanghai")
	type Alias ComponentList
	return json.Marshal(&struct {
		CreatedAt string `json:"CreatedAt,omitempty"`
		UpdatedAt string `json:"UpdatedAt,omitempty"`
		*Alias
	}{
		CreatedAt: ab.CreatedAt.In(loc).Format("2006-01-02 15:04:05"),
		UpdatedAt: ab.UpdatedAt.In(loc).Format("2006-01-02 15:04:05"),
		Alias:     (*Alias)(ab),
	})
}

func GetGetComponentList(componentId int) ([]ComponentList, error) {
	var componentList []ComponentList
	tx := global.DBLink.Where("component_id =?", componentId).Find(&componentList)
	if tx.Error != nil {
		return nil, tx.Error
	}
	return componentList, nil
}
