package app

import (
	middlewares "Panel_development/app/middleware"
	"Panel_development/app/routers"
	"Panel_development/configs"
	"github.com/gin-gonic/gin"
)

func InitRouter() error {
	engine := gin.New()
	routers.QiniuRouter(engine)
	engine.Use(middlewares.LoginMiddleware())
	gin.SetMode(configs.Config.GetString("server.mode"))
	routers.AdminRouter(engine)
	routers.ComponentClassRouter(engine)
	routers.ComponentListRouter(engine)
	routers.PageManageRouter(engine)
	return engine.Run(configs.Config.GetString("server.port"))
}
